package com.sunyard.chsm.service.impl;


import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.sunyard.chsm.mapper.KeyRecordMapper;
import com.sunyard.chsm.model.entity.KeyRecord;
import com.sunyard.chsm.service.KeyRecordService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.annotation.Resource;
import java.time.LocalDateTime;

/**
 * @author Cheney
 */
@Slf4j
@Service
@Transactional
public class KeyRecordServiceImpl implements KeyRecordService {

    @Resource
    private KeyRecordMapper keyRecordMapper;

    @Override
    public KeyRecord selectById(Long id) {
        return keyRecordMapper.selectById(id);
    }

    @Override
    public KeyRecord selectByKeyId(Long keyId) {
        LocalDateTime now = LocalDateTime.now();
        LambdaQueryWrapper<KeyRecord> queryWrapper = new LambdaQueryWrapper<>();
        // 添加 keyId 的条件
        queryWrapper.eq(KeyRecord::getKeyId, keyId);
        // 添加 effectiveTime 小于当前时间的条件
        queryWrapper.lt(KeyRecord::getEffectiveTime, now);
        // 添加 expiredTime 大于当前时间的条件
        queryWrapper.gt(KeyRecord::getExpiredTime, now);

        return keyRecordMapper.selectOne(queryWrapper);
    }
}
