package com.sunyard.chsm;

import com.sunyard.chsm.enums.KeyAlg;
import com.sunyard.chsm.sdf.BCSdfApiService;
import com.sunyard.chsm.sdf.SdfApiService;
import com.sunyard.chsm.sdf.model.EccKey;
import lombok.SneakyThrows;

import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.TimeUnit;

public class PerformanceTest {

    private static final long max = 100_000L;
    private static final SdfApiService service = new BCSdfApiService();
    private static final byte[] data = new byte[ 1024 ];

    @SneakyThrows
    public static void main(String[] args) {

        int numThreads = 16; // Number of threads to use
        Thread[] threads = new Thread[numThreads];

        long startTime = System.currentTimeMillis();
        for (int i = 0; i < numThreads; i++) {
            threads[i] = new Thread(() -> {
                testSM4();
            });
            threads[i].start();
        }


        for ( int i =0 ; i < numThreads; i++ ) {
            threads[i].join();
        }

        long endTime = System.currentTimeMillis();

        double tps = numThreads * max * 1000.0 / (endTime - startTime);
        System.out.println("SM4 TPS: " + String.format("%.02f", tps));

    }

//    private static void testSM2() {
//        long startTime = System.currentTimeMillis();
//        EccKey eccKey = service.genKeyPairEcc();
//
//        for (long i = 0; i < max; i++) {
//
//
//            service.asym
//
//        }
//
//        long endTime = System.currentTimeMillis();
//
//        System.out.println("Addition result: " + sum + ", Time taken: " + (endTime - startTime) + " ns");
//    }

    private static void testSM4() {

        byte[] key = service.generateRandom(16);
        for (long i = 0; i < max; i++) {
            byte[] enData = service.symEncrypt(KeyAlg.SM4, key, data);
            service.symDecrypt(KeyAlg.SM4, key, enData);
        }

    }
}
