package com.sunyard.chsm.config;

import lombok.extern.slf4j.Slf4j;
import org.springframework.web.servlet.HandlerInterceptor;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 拦截执行异常，返回错误码和提示信息
 * @author Cheney
 * @since 2024/11/13
 */
@Slf4j
public class ResHandler implements HandlerInterceptor {

    @Override
    public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
        return true;
    }

    @Override
    public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
        log.error("Error in call {}: {}", request.getRequestURI(), ex);

        HandlerInterceptor.super.afterCompletion(request, response, handler, ex);
    }
}
