package com.sunyard.chsm.service;


import cn.hutool.core.util.HexUtil;
import com.sunyard.chsm.enums.AlgMode;
import com.sunyard.chsm.enums.KeyAlg;
import com.sunyard.chsm.enums.Padding;
import com.sunyard.chsm.model.dto.KeyInfoDTO;
import com.sunyard.chsm.model.entity.KeyRecord;
import com.sunyard.chsm.sdf.SdfApiService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


/**
 *
 */
@Service
public class SYMEncryptService {
    @Autowired
    private SdfApiService sdf;

    @Autowired
    private KeyInfoService keyInfoService;

    @Autowired
    private KeyRecordService keyRecordService;


    public byte[] symEncrypt(KeyAlg alg, AlgMode mode, Padding padding, Long appId , Long keyId, byte[] iv, byte[] data) {
        // 查询 key 的值
        KeyRecord key = keyRecordService.selectByKeyId(keyId);
        // TODO 没有检查 appId


        // 验证 key


        // 计算
        return sdf.symEncrypt(
                alg, mode, padding,
                HexUtil.decodeHex(key.getKeyData()),
                iv,
                data
        );
    }

}
